# frozen_string_literal: true

require 'bamboozled'
require_relative "hr_tool"
require_relative 'wrappers/bamboo_team_member'

module PeopleGroup
  module HRIS
    class BambooHR < HRTool
      def self.all
        @@fields ||= (Bamboozled::API::FieldCollection.all_names + client.meta.fields.map { |f| f['alias'] }).compact.uniq
        @@fields.delete('flsaCode') # temp fix for problems with BambooHR
        @@all ||= client.report.custom(@@fields, 'JSON').reject { |employee| employee['lastName'] == 'Test-Gitlab' }
      end

      def self.map_to_team_member(data)
        PeopleGroup::HRIS::Wrappers::BambooTeamMember.new(data)
      end

      private

      def self.client
        @@client ||= Bamboozled.client(subdomain: ENV['BAMBOO_SUBDOMAIN'], api_key: ENV['BAMBOO_API_KEY'])
      end
    end
  end
end
