# frozen_string_literal: true

module PeopleGroup
  module HRIS
    class TeamMembers
      def self.all
        @@all ||= hr_tool.all.map! { |data| hr_tool.map_to_team_member(data) }
      end

      def self.active
        all.select { |team_member| team_member.active? }
      end

      def self.active_and_current
        today = Date.current
        all.select { |team_member| team_member.active? && team_member.start_date <= today }
      end

      private

      def self.hr_tool
        BambooHR # TODO can we set this on config
      end
    end
  end
end
