module PeopleGroup
  module HRIS
    module Wrappers
      class TeamMember
        REQUIRED_METHODS = %w[first_name last_name active? start_date
                              specialties, gitlab_username, work_email,
                              offboarded? department division team_member_id]

        REQUIRED_METHODS.each do |method|
          define_method("#{method}") do
            raise NotImplementedError
          end
        end

        def full_name
          "#{first_name} #{last_name}"
        end
      end
    end
  end
end